import * as React from 'react';
/**
 * Viewport component allow tracking the component when it appears in the viewport
 */
export declare class Viewport extends React.Component<Props> {
    static defaultProps: Partial<DataProps>;
    private readonly screenRef;
    private isInScreen;
    private enterCount;
    private isEntered;
    private leaveCount;
    private isLeft;
    constructor(props: Props);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private handleScroll;
    private getWidthHeight;
}
declare type Props = DataProps & EventProps;
interface DataProps {
    /** React component node */
    children: JSX.Element | string;
    /** Delay time for scroll event */
    delay?: number;
    /** Type of check component if it is in the viewport */
    type?: Type;
    /** Id of element */
    id?: string;
    /** Custom CSS class */
    className?: string;
}
interface EventProps {
    /** When component is in the viewport, event will be executed */
    onEnter: (enterCount?: number) => void;
    /** When component is not in the viewport, event will be executed */
    onLeave?: (leaveCount?: number) => void;
}
export interface Size {
    width: number;
    height: number;
}
declare type Type = 'fit' | 'overlap';
export {};
