"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var throttle_debounce_1 = require("throttle-debounce");
var utils_1 = require("./utils");
/**
 * Viewport component allow tracking the component when it appears in the viewport
 */
var Viewport = /** @class */ (function (_super) {
    __extends(Viewport, _super);
    function Viewport(props) {
        var _this = _super.call(this, props) || this;
        _this.screenRef = React.createRef();
        _this.handleScroll = function () {
            var size = _this.getWidthHeight();
            var rect = _this.screenRef.current.getBoundingClientRect();
            if (_this.isInScreen(size, rect)) {
                if (!_this.isEntered && _this.props.onEnter) {
                    _this.enterCount++;
                    _this.props.onEnter(_this.enterCount);
                    _this.isEntered = true;
                    _this.isLeft = false;
                }
            }
            else if (_this.isEntered && !_this.isLeft && _this.props.onLeave) {
                _this.leaveCount++;
                _this.props.onLeave(_this.leaveCount);
                _this.isLeft = true;
                _this.isEntered = false;
            }
        };
        _this.enterCount = 0;
        _this.isEntered = false;
        _this.leaveCount = 0;
        _this.isLeft = false;
        var func = {
            fit: utils_1.isFittedIn,
            overlap: utils_1.isOverlapping
        };
        _this.isInScreen = func[_this.props.type];
        return _this;
    }
    Viewport.prototype.componentDidMount = function () {
        window.addEventListener('scroll', throttle_debounce_1.throttle(this.props.delay, this.handleScroll), {
            passive: true
        });
    };
    Viewport.prototype.componentWillUnmount = function () {
        window.removeEventListener('scroll', this.handleScroll);
    };
    Viewport.prototype.render = function () {
        return (React.createElement("div", { className: this.props.className, id: this.props.id, ref: this.screenRef }, this.props.children));
    };
    Viewport.prototype.getWidthHeight = function () {
        var height = window.innerHeight || document.documentElement.clientHeight;
        var width = window.innerWidth || document.documentElement.clientWidth;
        return { width: width, height: height };
    };
    Viewport.defaultProps = {
        type: 'fit',
        delay: 100
    };
    return Viewport;
}(React.Component));
exports.Viewport = Viewport;
